---
title: RegExp() constructor
slug: Web/JavaScript/Reference/Global_Objects/RegExp/RegExp
tags:
  - Constructor
  - JavaScript
  - Reference
  - RegExp
---
<div>{{JSRef}}</div>

<p>The <strong><code>RegExp</code></strong> constructor creates a regular expression object for matching text with a pattern.</p>

<p>For an introduction to regular expressions, read the <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">Regular Expressions chapter</a> in the <a href="/en-US/docs/Web/JavaScript/Guide">JavaScript Guide</a>.</p>

<div>{{EmbedInteractiveExample("pages/js/regexp-constructor.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<p>Literal, constructor, and factory notations are possible:</p>

<pre class="syntaxbox notranslate">/<var>pattern</var>/<var>flags</var>
new RegExp(<var>pattern</var>[, <var>flags</var>])
RegExp(<var>pattern</var>[, <var>flags</var>])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>pattern</var></code></dt>
 <dd>The text of the regular expression.</dd>
 <dd>As of ES5, this can also be another <code>RegExp</code> object or literal (for the two RegExp constructor notations only). Patterns may include <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions#Using_special_characters">special characters</a> to match a wider range of values than would a literal string.</dd>
 <dt><code><var>flags</var></code></dt>
 <dd>
 <p>If specified, <code><var>flags</var></code> is a string that contains the flags to add.</p>

 <p>Alternatively, if an object is supplied for the pattern, the <code><var>flags</var></code> string will replace any of that object's flags (and <code>lastIndex</code> will be reset to <code>0</code>) (as of ES2015).</p>

 <p>If <code><var>flags</var></code> is not specified and a regular expressions object is supplied, that object's flags (and <code>lastIndex</code> value) will be copied over.</p>

 <p><code><var>flags</var></code> may contain any combination of the following characters:</p>

 <dl>
  <dt><code>g</code> (global match)</dt>
  <dd>Find all matches rather than stopping after the first match.</dd>
  <dt><code>i</code> (ignore case)</dt>
  <dd>If <code>u</code> flag is also enabled, use Unicode case folding.</dd>
  <dt><code>m</code> (multiline)</dt>
  <dd>Treat beginning and end characters (<code>^</code> and <code>$</code>) as working over multiple lines. In other words, match the beginning or end of <em>each</em> line (delimited by <code>\n</code> or <code>\r</code>), not only the very beginning or end of the whole input string.</dd>
  <dt><code>s</code> ("dotAll")</dt>
  <dd>Allows <code>.</code> to match newlines.</dd>
  <dt><code>u</code> (unicode)</dt>
  <dd>Treat <code><var>pattern</var></code> as a sequence of Unicode code points. (See also <a href="/en-US/docs/Web/API/DOMString/Binary">Binary strings</a>).</dd>
  <dt><code>y</code> (sticky)</dt>
  <dd>Matches only from the index indicated by the <code>lastIndex</code> property of this regular expression in the target string. Does not attempt to match from any later indexes.</dd>
 </dl>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Literal_notation_and_constructor">Literal notation and constructor</h3>

<p>There are two ways to create a <code>RegExp</code> object: a <em>literal notation</em> and a <em>constructor</em>.</p>

<ul>
 <li><strong>The literal notation's</strong> parameters are enclosed between slashes and do not use quotation marks.</li>
 <li><strong>The constructor function's</strong> parameters are not enclosed between slashes but do use quotation marks.</li>
</ul>

<p>The following three expressions create the same regular expression:</p>

<pre class="brush: js notranslate">/ab+c/i
new RegExp(/ab+c/, 'i') // literal notation
new RegExp('ab+c', 'i') // constructor
</pre>

<p>The literal notation results in compilation of the regular expression when the expression is evaluated. Use literal notation when the regular expression will remain constant. For example, if you use literal notation to construct a regular expression used in a loop, the regular expression won't be recompiled on each iteration.</p>

<p>The constructor of the regular expression object—for example, <code>new RegExp('ab+c')</code>—results in runtime compilation of the regular expression. Use the constructor function when you know the regular expression pattern will be changing, or you don't know the pattern and are getting it from another source, such as user input.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-regexp-constructor', 'RegExp constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.RegExp")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">Regular Expressions</a> chapter in the <a href="/en-US/docs/Web/JavaScript/Guide">JavaScript Guide</a></li>
 <li>{{jsxref("String.prototype.match()")}}</li>
 <li>{{jsxref("String.prototype.replace()")}}</li>
</ul>
